Index: /trunk/sources/HeuristicLab.Assignment.QAP/HeuristicLab.Assignment.QAP.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/HeuristicLab.Assignment.QAP.csproj	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/HeuristicLab.Assignment.QAP.csproj	(revision 1241)
@@ -0,0 +1,120 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.21022</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Assignment.QAP</RootNamespace>
+    <AssemblyName>HeuristicLab.Assignment.QAP-3.2</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <StartupObject>
+    </StartupObject>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Properties\Resources.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>Resources.resx</DependentUpon>
+    </Compile>
+    <Compile Include="QAPEvaluator.cs" />
+    <Compile Include="QAPInjector.cs" />
+    <Compile Include="QAPInjectorView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="QAPInjectorView.Designer.cs">
+      <DependentUpon>QAPInjectorView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="QAPParser.cs" />
+    <Compile Include="QAPPlugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Charting\HeuristicLab.Charting.csproj">
+      <Project>{B462D3CC-8866-42F0-9832-AD0967613B72}</Project>
+      <Name>HeuristicLab.Charting</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Core\HeuristicLab.Core.csproj">
+      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
+      <Name>HeuristicLab.Core</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Data\HeuristicLab.Data.csproj">
+      <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
+      <Name>HeuristicLab.Data</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Operators\HeuristicLab.Operators.csproj">
+      <Project>{A9983BA2-B3B2-475E-8E2C-62050B71D1C5}</Project>
+      <Name>HeuristicLab.Operators</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Permutation\HeuristicLab.Permutation.csproj">
+      <Project>{55FDCFB3-3E8C-4FB0-837C-0CF06BEDED39}</Project>
+      <Name>HeuristicLab.Permutation</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Properties\AssemblyInfo.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Properties\Resources.resx">
+      <Generator>ResXFileCodeGenerator</Generator>
+      <LastGenOutput>Resources.Designer.cs</LastGenOutput>
+    </EmbeddedResource>
+    <EmbeddedResource Include="QAPInjectorView.resx">
+      <DependentUpon>QAPInjectorView.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <PropertyGroup>
+    <PostBuildEvent>
+    </PostBuildEvent>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: /trunk/sources/HeuristicLab.Assignment.QAP/Properties/AssemblyInfo.frame
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/Properties/AssemblyInfo.frame	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/Properties/AssemblyInfo.frame	(revision 1241)
@@ -0,0 +1,38 @@
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+using HeuristicLab.PluginInfrastructure;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Assignment.QAP-3.2")]
+[assembly: AssemblyDescription("HeuristicLab")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("d902f071-7910-459f-8d25-bbf43fc3c5a3")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyFileVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyBuildDate("$WCNOW$")]
Index: /trunk/sources/HeuristicLab.Assignment.QAP/QAPEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/QAPEvaluator.cs	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/QAPEvaluator.cs	(revision 1241)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Assignment.QAP {
+  public class QAPEvaluator : SingleObjectiveEvaluatorBase {
+    public QAPEvaluator()
+      : base() {
+      AddVariableInfo(new VariableInfo("Distances", "Distance matrix for given locations", typeof(DoubleMatrixData), VariableKind.In));
+      AddVariableInfo(new VariableInfo("Weights", "Weight matrix denoting the flow strength between different facilities", typeof(DoubleMatrixData), VariableKind.In));
+      AddVariableInfo(new VariableInfo("Permutation", "Permutation representing a QAP assignment of facilities to locations", typeof(Permutation.Permutation), VariableKind.In));
+    }
+
+    protected override double Evaluate(IScope scope) {
+      double[,] distances = GetVariableValue<DoubleMatrixData>("Distances", scope, true).Data;
+      double[,] weights = GetVariableValue<DoubleMatrixData>("Weights", scope, true).Data;
+      int[] perm = GetVariableValue<Permutation.Permutation>("Permutation", scope, false).Data;
+      double costs = 0;
+
+      for (int i = 0; i < perm.Length; i++) {
+        for (int j = 0; j < perm.Length; j++) {
+          costs += distances[i, j] * weights[perm[i], perm[j]];
+        }
+      }
+      return costs;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjector.cs	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjector.cs	(revision 1241)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Assignment.QAP {
+  public class QAPInjector : OperatorBase {
+    public override string Description {
+      get { return @"Injector for quadratic assignment problem (QAP) files..."; }
+    }
+
+    public QAPInjector() : base() {
+      AddVariableInfo(new VariableInfo("Maximization", "Set to false as QAP is a minimization problem", typeof(BoolData), VariableKind.New));
+      AddVariableInfo(new VariableInfo("Facilities", "Number of facilities", typeof(IntData), VariableKind.New));
+      AddVariable(new Variable("Facilities", new IntData(0)));
+      AddVariableInfo(new VariableInfo("Distances", "Facility distances", typeof(DoubleMatrixData), VariableKind.New));
+      AddVariable(new Variable("Distances", new DoubleMatrixData(new double[0,0])));
+      AddVariableInfo(new VariableInfo("Weights", "Facility flow values", typeof(DoubleMatrixData), VariableKind.New));
+      AddVariable(new Variable("Weights", new DoubleMatrixData(new double[0, 0])));
+      AddVariableInfo(new VariableInfo("BestKnownQuality", "Quality of best known solution", typeof(DoubleData), VariableKind.New));
+      AddVariable(new Variable("InjectBestKnownQuality", new BoolData(false)));
+      AddVariable(new Variable("BestKnownQuality", new DoubleData(0)));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      scope.AddVariable(new Variable(scope.TranslateName("Maximization"), new BoolData(false)));
+      scope.AddVariable(new Variable(scope.TranslateName("Facilities"), (IItem)GetVariable("Facilities").Value.Clone()));
+      scope.AddVariable(new Variable(scope.TranslateName("Distances"), (IItem)GetVariable("Distances").Value.Clone()));
+      scope.AddVariable(new Variable(scope.TranslateName("Weights"), (IItem)GetVariable("Weights").Value.Clone()));
+      if (GetVariable("InjectBestKnownQuality").GetValue<BoolData>().Data)
+        scope.AddVariable(new Variable(scope.TranslateName("BestKnownQuality"), (IItem)GetVariable("BestKnownQuality").Value.Clone()));
+      return null;
+    }
+
+    public override IView CreateView() {
+      return new QAPInjectorView(this);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.Designer.cs	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.Designer.cs	(revision 1241)
@@ -0,0 +1,204 @@
+﻿namespace HeuristicLab.Assignment.QAP {
+  partial class QAPInjectorView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.loadButton = new System.Windows.Forms.Button();
+      this.facilitiesTextBox = new System.Windows.Forms.TextBox();
+      this.qualTextBox = new System.Windows.Forms.TextBox();
+      this.label1 = new System.Windows.Forms.Label();
+      this.label2 = new System.Windows.Forms.Label();
+      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
+      this.knownQualCheckBox = new System.Windows.Forms.CheckBox();
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.dataTabPage = new System.Windows.Forms.TabPage();
+      this.varInfoTabPage = new System.Windows.Forms.TabPage();
+      this.descriptionTabPage = new System.Windows.Forms.TabPage();
+      this.operatorBaseVariableInfosView = new HeuristicLab.Core.OperatorBaseVariableInfosView();
+      this.operatorBaseDescriptionView = new HeuristicLab.Core.OperatorBaseDescriptionView();
+      this.tabControl.SuspendLayout();
+      this.dataTabPage.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // loadButton
+      // 
+      this.loadButton.Location = new System.Drawing.Point(11, 96);
+      this.loadButton.Name = "loadButton";
+      this.loadButton.Size = new System.Drawing.Size(231, 24);
+      this.loadButton.TabIndex = 0;
+      this.loadButton.Text = "Load QAP file";
+      this.loadButton.UseVisualStyleBackColor = true;
+      this.loadButton.Click += new System.EventHandler(this.loadButton_Click);
+      // 
+      // facilitiesTextBox
+      // 
+      this.facilitiesTextBox.Location = new System.Drawing.Point(167, 11);
+      this.facilitiesTextBox.Name = "facilitiesTextBox";
+      this.facilitiesTextBox.Size = new System.Drawing.Size(78, 20);
+      this.facilitiesTextBox.TabIndex = 2;
+      this.facilitiesTextBox.TextChanged += new System.EventHandler(this.facilitiesTextBox_TextChanged);
+      // 
+      // qualTextBox
+      // 
+      this.qualTextBox.Location = new System.Drawing.Point(167, 64);
+      this.qualTextBox.Name = "qualTextBox";
+      this.qualTextBox.Size = new System.Drawing.Size(78, 20);
+      this.qualTextBox.TabIndex = 3;
+      this.qualTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.qualTextBox_Validating);
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(15, 14);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(50, 13);
+      this.label1.TabIndex = 4;
+      this.label1.Text = "Facilities:";
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(15, 66);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(96, 13);
+      this.label2.TabIndex = 5;
+      this.label2.Text = "Best Know Quality:";
+      // 
+      // openFileDialog
+      // 
+      this.openFileDialog.FileName = "openFileDialog1";
+      // 
+      // knownQualCheckBox
+      // 
+      this.knownQualCheckBox.AutoSize = true;
+      this.knownQualCheckBox.Location = new System.Drawing.Point(14, 39);
+      this.knownQualCheckBox.Name = "knownQualCheckBox";
+      this.knownQualCheckBox.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
+      this.knownQualCheckBox.Size = new System.Drawing.Size(167, 17);
+      this.knownQualCheckBox.TabIndex = 6;
+      this.knownQualCheckBox.Text = "Best Known Quality Available:";
+      this.knownQualCheckBox.UseVisualStyleBackColor = true;
+      this.knownQualCheckBox.CheckedChanged += new System.EventHandler(this.knownQualCheckBox_CheckedChanged);
+      // 
+      // tabControl
+      // 
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.dataTabPage);
+      this.tabControl.Controls.Add(this.varInfoTabPage);
+      this.tabControl.Controls.Add(this.descriptionTabPage);
+      this.tabControl.Location = new System.Drawing.Point(3, 3);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(256, 152);
+      this.tabControl.TabIndex = 7;
+      // 
+      // dataTabPage
+      // 
+      this.dataTabPage.Controls.Add(this.loadButton);
+      this.dataTabPage.Controls.Add(this.knownQualCheckBox);
+      this.dataTabPage.Controls.Add(this.label1);
+      this.dataTabPage.Controls.Add(this.label2);
+      this.dataTabPage.Controls.Add(this.facilitiesTextBox);
+      this.dataTabPage.Controls.Add(this.qualTextBox);
+      this.dataTabPage.Location = new System.Drawing.Point(4, 22);
+      this.dataTabPage.Name = "dataTabPage";
+      this.dataTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.dataTabPage.Size = new System.Drawing.Size(248, 126);
+      this.dataTabPage.TabIndex = 0;
+      this.dataTabPage.Text = "QAP Data";
+      this.dataTabPage.UseVisualStyleBackColor = true;
+      // 
+      // operatorBaseVariableInfosView
+      // 
+      this.operatorBaseVariableInfosView.Caption = "Operator";
+      this.operatorBaseVariableInfosView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.operatorBaseVariableInfosView.Location = new System.Drawing.Point(3, 3);
+      this.operatorBaseVariableInfosView.Name = "operatorBaseVariableInfosView";
+      this.operatorBaseVariableInfosView.Operator = null;
+      this.operatorBaseVariableInfosView.Size = new System.Drawing.Size(262, 152);
+      this.operatorBaseVariableInfosView.TabIndex = 0;
+      // 
+      // varInfoTabPage
+      // 
+      this.varInfoTabPage.Controls.Add(this.operatorBaseVariableInfosView);
+      this.varInfoTabPage.Location = new System.Drawing.Point(4, 22);
+      this.varInfoTabPage.Name = "varInfoTabPage";
+      this.varInfoTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.varInfoTabPage.Size = new System.Drawing.Size(453, 166);
+      this.varInfoTabPage.TabIndex = 1;
+      this.varInfoTabPage.Text = "Variable Infos";
+      this.varInfoTabPage.UseVisualStyleBackColor = true;
+      // 
+      // operatorBaseDescriptionView
+      // 
+      this.operatorBaseDescriptionView.Caption = "Operator";
+      this.operatorBaseDescriptionView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.operatorBaseDescriptionView.Location = new System.Drawing.Point(3, 3);
+      this.operatorBaseDescriptionView.Name = "operatorBaseDescriptionView";
+      this.operatorBaseDescriptionView.Operator = null;
+      this.operatorBaseDescriptionView.Size = new System.Drawing.Size(262, 152);
+      this.operatorBaseDescriptionView.TabIndex = 0;
+      // 
+      // descriptionTabPage
+      // 
+      this.descriptionTabPage.Controls.Add(this.operatorBaseDescriptionView);
+      this.descriptionTabPage.Location = new System.Drawing.Point(4, 22);
+      this.descriptionTabPage.Name = "descriptionTabPage";
+      this.descriptionTabPage.Size = new System.Drawing.Size(453, 166);
+      this.descriptionTabPage.TabIndex = 2;
+      this.descriptionTabPage.Text = "Description";
+      this.descriptionTabPage.UseVisualStyleBackColor = true;
+      // 
+      // QAPInjectorView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tabControl);
+      this.Name = "QAPInjectorView";
+      this.Size = new System.Drawing.Size(262, 156);
+      this.tabControl.ResumeLayout(false);
+      this.dataTabPage.ResumeLayout(false);
+      this.dataTabPage.PerformLayout();
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button loadButton;
+    private System.Windows.Forms.TextBox facilitiesTextBox;
+    private System.Windows.Forms.TextBox qualTextBox;
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.OpenFileDialog openFileDialog;
+    private System.Windows.Forms.CheckBox knownQualCheckBox;
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage dataTabPage;
+    private System.Windows.Forms.TabPage varInfoTabPage;
+    private System.Windows.Forms.TabPage descriptionTabPage;
+    private HeuristicLab.Core.OperatorBaseVariableInfosView operatorBaseVariableInfosView;
+    private HeuristicLab.Core.OperatorBaseDescriptionView operatorBaseDescriptionView;
+  }
+}
Index: /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.cs	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.cs	(revision 1241)
@@ -0,0 +1,107 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Assignment.QAP {
+  public partial class QAPInjectorView : ViewBase {
+
+    public QAPInjectorView() {
+      InitializeComponent();
+    }
+
+    public QAPInjector injector {
+      get { return (QAPInjector)Item; }
+      set { base.Item = value; }
+    }
+
+    public QAPInjectorView(QAPInjector injector) : this() {
+      this.injector = injector; 
+    }
+
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      if (injector == null) {
+        facilitiesTextBox.Text = "-";
+        facilitiesTextBox.Enabled = false;
+        knownQualCheckBox.Checked = false;
+        knownQualCheckBox.Enabled = false; 
+        qualTextBox.Visible = false; 
+        qualTextBox.Enabled = false;
+      } else {
+        facilitiesTextBox.Text = injector.GetVariable("Facilities").Value.ToString();
+        knownQualCheckBox.Checked = injector.GetVariable("InjectBestKnownQuality").GetValue<BoolData>().Data;
+        knownQualCheckBox.Enabled = true;
+        if (knownQualCheckBox.Checked) {
+          qualTextBox.Text = injector.GetVariable("BestKnownQuality").Value.ToString();
+          qualTextBox.Enabled = true;
+        } else {
+          qualTextBox.Text = "-";
+          qualTextBox.Enabled = false;
+        }
+      }
+    }
+
+    private void loadButton_Click(object sender, EventArgs e) {
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        QAPParser parser = null;
+        bool success = false;
+        try {
+          parser = new QAPParser();
+          parser.Parse(openFileDialog.FileName);
+          success = true;
+        } catch (Exception ex) {
+          MessageBox.Show(this, ex.Message, ex.GetType().Name, MessageBoxButtons.OK, MessageBoxIcon.Error);
+        }
+        if (success) {
+          injector.GetVariable("Facilities").Value = new IntData(parser.facilities);
+          injector.GetVariable("Distances").Value = new DoubleMatrixData(parser.distances);
+          injector.GetVariable("Weights").Value = new DoubleMatrixData(parser.weights);
+          Refresh();
+        }
+      }
+    }
+
+    protected override void RemoveItemEvents() {
+      operatorBaseVariableInfosView.Operator = null;
+      operatorBaseDescriptionView.Operator = null;
+      base.RemoveItemEvents();
+    }
+
+    protected override void AddItemEvents() {
+      base.AddItemEvents();
+      operatorBaseVariableInfosView.Operator = injector;
+      operatorBaseDescriptionView.Operator = injector;
+    }
+
+    private void knownQualCheckBox_CheckedChanged(object sender, EventArgs e) {
+      injector.GetVariable("InjectBestKnownQuality").GetValue<BoolData>().Data = knownQualCheckBox.Checked;
+      if (knownQualCheckBox.Checked) {
+        qualTextBox.Text = injector.GetVariable("BestKnownQuality").Value.ToString();
+        qualTextBox.Enabled = true;
+      } else {
+        qualTextBox.Text = "-";
+        qualTextBox.Enabled = false;
+      }
+    }
+
+    private void qualTextBox_Validating(object sender, CancelEventArgs e) {
+      e.Cancel = false;
+      try {
+        injector.GetVariable("BestKnownQuality").GetValue<DoubleData>().Data = double.Parse(qualTextBox.Text);
+      } catch (Exception) {
+        qualTextBox.SelectAll();
+        e.Cancel = true;
+      }
+    }
+
+    private void facilitiesTextBox_TextChanged(object sender, EventArgs e) {
+
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.resx
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.resx	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/QAPInjectorView.resx	(revision 1241)
@@ -0,0 +1,123 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <metadata name="openFileDialog.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>17, 17</value>
+  </metadata>
+</root>
Index: /trunk/sources/HeuristicLab.Assignment.QAP/QAPParser.cs
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/QAPParser.cs	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/QAPParser.cs	(revision 1241)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.IO;
+
+namespace HeuristicLab.Assignment.QAP {
+  public class QAPParser {
+    public int facilities;
+    public double[,] distances;
+    public double[,] weights; 
+    
+    public QAPParser() { 
+    }
+
+    public bool Parse(string file) {
+      try {
+        StreamReader reader = new StreamReader(file);
+        facilities = int.Parse(reader.ReadLine());
+        distances = new double[facilities, facilities];
+        weights = new double[facilities, facilities];
+        reader.ReadLine();
+        char[] delim = new char[] {' '};
+        for (int i = 0; i < facilities; i++) {
+          string valLine = reader.ReadLine();
+          string[] vals = new string[facilities]; 
+          string[] partVals =  valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries); 
+          partVals.CopyTo(vals, 0);
+          int index = partVals.Length; 
+          while (index < facilities) {
+            valLine = reader.ReadLine();
+            partVals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
+            partVals.CopyTo(vals, index);
+            index += partVals.Length; 
+          }
+          for (int j = 0; j < facilities; j++) {
+            distances[i, j] = double.Parse(vals[j]);
+          }
+        }
+        reader.ReadLine();
+        int read = 0;
+        int k = 0;
+        while (!reader.EndOfStream) {
+          string valLine = reader.ReadLine();
+          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
+          for (int j = 0; j < vals.Length; j++) {
+            if (read + j == facilities) {
+              read = 0;
+              k++;
+            }
+            weights[k, read + j] = double.Parse(vals[j]);
+          }
+          read += vals.Length; 
+        }
+        return true; 
+      } catch (Exception) { 
+        // not good
+        return false; 
+      }
+
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Assignment.QAP/QAPPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Assignment.QAP/QAPPlugin.cs	(revision 1241)
+++ /trunk/sources/HeuristicLab.Assignment.QAP/QAPPlugin.cs	(revision 1241)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Assignment.QAP {
+  [ClassInfo(Name = "HeuristicLab.Assignment.QAP-3.2")]
+  [PluginFile(Filename = "HeuristicLab.Assignment.QAP-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  public class QAPPlugin : PluginBase {
+  }
+}
Index: /trunk/sources/HeuristicLab.sln
===================================================================
--- /trunk/sources/HeuristicLab.sln	(revision 1240)
+++ /trunk/sources/HeuristicLab.sln	(revision 1241)
@@ -133,4 +133,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.IntVector", "HeuristicLab.IntVector\HeuristicLab.IntVector.csproj", "{85FA46C6-761E-4098-9EF7-060ECC386396}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Assignment.QAP", "HeuristicLab.Assignment.QAP\HeuristicLab.Assignment.QAP.csproj", "{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}"
 EndProject
 Global
@@ -1038,4 +1040,16 @@
 		{85FA46C6-761E-4098-9EF7-060ECC386396}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
 		{85FA46C6-761E-4098-9EF7-060ECC386396}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Release|Any CPU.Build.0 = Release|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Release|x86.ActiveCfg = Release|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 1240)
+++ /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 1241)
@@ -10,4 +10,5 @@
 copy "%SolutionDir%\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking License.txt" .\plugins
+copy "%SolutionDir%\HeuristicLab.Assignment.QAP\%Outdir%\HeuristicLab.Assignment.QAP-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.BitVector\%Outdir%\HeuristicLab.BitVector-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.CEDMA.Charting\%Outdir%\HeuristicLab.CEDMA.Charting-3.2.dll" .\plugins
